const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const bom_lines = sequelize.define(
    'bom_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_per: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_factor: {
        type: DataTypes.DECIMAL,
      
      

      },

issue_method: {
        type: DataTypes.ENUM,
      
      

        values: [

"backflush",


"manual",


"kitted"

        ],

      },

reference_designator: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  bom_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




































//end loop



    db.bom_lines.belongsTo(db.boms, {
      as: 'bom',
      foreignKey: {
        name: 'bomId',
      },
      constraints: false,
    });

    db.bom_lines.belongsTo(db.materials, {
      as: 'component_material',
      foreignKey: {
        name: 'component_materialId',
      },
      constraints: false,
    });

    db.bom_lines.belongsTo(db.units_of_measure, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });




    db.bom_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.bom_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return bom_lines;
};


